biostar/forum/urls.py
from django.conf import settings
from django.contrib import admin
from django.conf.urls.static import static
from django.urls import include, path, re_path  # For django versions from 2.0 and up
import debug_toolbar
from biostar.forum import views, moderate, herald
from biostar.accounts.views import image_upload_view
from biostar.forum import ajax, api, feed
import biostar.accounts.views as account_views
from biostar.accounts.urls import account_patterns

from biostar.planet.urls import planet_patterns


forum_patterns = [

    # Main entry. Post listing.
    path('', views.latest, name='post_list'),

    path(r'info/<str:fname>/', views.pages, name='pages'),

    path('votes/', views.myvotes, name='myvotes'),
    path('bookmarks/', views.bookmarks, name='bookmarks'),
    path('following/', views.following, name='following'),
    path('myposts/', views.myposts, name='myposts'),
    path('mytags/', views.mytags, name='mytags'),
    path('p/<str:uid>/', views.post_view, name='post_view'),

    re_path(r'^t/(?P<topic>.+)/$', views.post_topic, name='post_topic'),
    path('post/search/', views.post_search, name='post_search'),

    path('new/post/', views.new_post, name='post_create'),

    path('b/list/', views.badge_list, name='badge_list'),
    path('t/', views.tags_list, name='tags_list'),
    re_path(r'^tag/(?P<tag>.+)/$', views.post_tags, name='post_tags'),

    path('b/view/<str:uid>/', views.badge_view, name='badge_view'),

    # Ajax calls
    path('ajax/digest/', ajax.ajax_digest, name='ajax_digest'),
    path('ajax/vote/', ajax.ajax_vote, name='vote'),
    path('ajax/test/', ajax.ajax_test, name='ajax_test'),
    path('ajax/subscribe/', ajax.ajax_subs, name='ajax_sub'),
    path('ajax/delete/', ajax.ajax_delete, name='ajax_delete'),
    path('drag/and/drop/', ajax.drag_and_drop, name='drag_and_drop'),
    path('similar/posts/<str:uid>/', ajax.similar_posts, name='similar_posts'),
    path('ajax/digest/<str:uid>/', ajax.ajax_digest, name='ajax_digest'),
    path('ajax/edit/<str:uid>/', ajax.ajax_edit, name='ajax_edit'),
    path('ajax/comment/create/', ajax.ajax_comment_create, name='ajax_comment_create'),
    path('inplace/form/', ajax.inplace_form, name='inplace_form'),
    path('ajax/user/image/<str:username>/', ajax.user_image, name='user_image'),
    path('similar/posts/<str:uid>/', ajax.similar_posts, name='similar_posts'),
    path('view/diffs/<str:uid>/', ajax.view_diff, name='view_diff'),
    path('email/disable/<int:uid>/', ajax.email_disable, name='email_disable'),

    path('moderate/<str:uid>/', moderate.post_moderate, name="post_moderate"),

    path(r'mark/spam/<str:uid>/', views.mark_spam, name='mark_spam'),
    path(r'mark/spam/<str:uid>/', views.release_quar, name='release_quar'),

    # Community urls
    path('user/list/', views.community_list, name='community_list'),
    path('ajax/handle/search/', ajax.handle_search, name='handle_search'),

    # Api calls
    path(r'api/traffic/', api.traffic, name='api_traffic'),
    path(r'api/user/<str:uid>/', api.user_details, name='api_user'),
    path(r'api/tag/<str:tag>/', api.api_tag, name='api_tag'),
    path(r'api/tags/list/', api.tags_list, name='api_tags_list'),
    path(r'api/post/<str:uid>/', api.post_details, name='api_post'),
    path(r'api/vote/<int:uid>/', api.vote_details, name='api_vote'),
    path(r'api/watched/tags/<str:email>/', api.watched_tags, name='api_tags'),
    path(r'api/email/<str:email>/', api.user_email, name='user_email'),
    path(r'api/stats/day/<int:day>/', api.daily_stats_on_day, name='api_stats_on_day'),
    path(r'api/stats/date/<int:year>/<int:month>/<int:day>/', api.daily_stats_on_date,
         name='api_stats_on_date'),

    # Log view
    path(r'view/logs/', views.view_logs, name='view_logs'),

    # Error check.
    path(r'error/', views.error, name="error"),

    # Herald url
    path('herald/', herald.herald_list, name="herald_list"),
    path('herald/update/<int:pk>/', ajax.herald_update, name="herald_update"),
    path('herald/publish/', herald.herald_publish, name="herald_publish"),
    path('herald/subscribe/', ajax.herald_subscribe, name="herald_subscribe"),

    # RSS feeds
    path(r'feeds/latest/', feed.LatestFeed(), name='latest_feed'),
    path(r'feeds/tag/<str:text>/', feed.TagFeed(), name='tag_feed'),
    path(r'feeds/user/<str:text>/', feed.UserFeed(), name='user_feed'),
    path(r'feeds/post/<str:text>/', feed.PostFeed(), name='post_feed' ),
    path(r'feeds/type/<str:text>/', feed.PostTypeFeed(), name='post_type'),
    #path(r'^feeds/planet/$', feed.PlanetFeed(), name='planet-feed'),
    path(r'merge/', views.merge_profile, name="merge_profile"),

]


urlpatterns = [

    # Main entry. Post listing.
    path('', include(forum_patterns)),

    # Override the moderate
    path(r'accounts/moderate/<str:uid>/', moderate.user_moderate, name="user_moderate"),

    # Include the accounts urls
    path('accounts/', include(account_patterns)),

    # User profile url
    path(r'u/<str:uid>/', account_views.user_profile, name="user_profile"),

    # Include the planet urls
    path('planet/', include(planet_patterns)),

    # Add admin urls.
    path('admin/', admin.site.urls),

]

if settings.PAGEDOWN_IMAGE_UPLOAD_ENABLED:

    urlpatterns += [
        # Pagedown image upload url.
        path('pagedown/image-upload/', image_upload_view, name="pagedown-image-upload")
    ]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT, show_indexes=True)
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT, show_indexes=True)

if settings.DEBUG and settings.DEBUG_TOOLBAR:
    urlpatterns += [
          path('__debug__/', include(debug_toolbar.urls)),
    ]

biostar/planet/urls.py
from django.urls import path, include
from biostar.planet import views
from django.contrib import admin


planet_patterns = [
    path('', views.blog_list, name="blog_list"),
    path(r'view/<int:id>/', views.blog_view, name="blog_view"),
    path(r'bump/<int:id>/', views.blog_bump, name="blog_bump"),
]

urlpatterns = [

    # Get the reset/ urls
    path(r'', include(planet_patterns)),
    # Add admin urls.
    path('admin/', admin.site.urls),

]

biostar/server/urls.py
from django.conf import settings
from django.urls import path, include
from django.contrib import admin
import debug_toolbar
from django.conf.urls.static import static
from biostar.forum.urls import forum_patterns
from biostar.accounts.views import image_upload_view
from biostar.recipes.urls import recipes_patterns
import biostar.accounts.urls as accounts_urls
from biostar.planet.urls import planet_patterns


urlpatterns = [

    # Mount recipes urls on root.
    path(r'', include(recipes_patterns)),

    # Include forum urls
    path(r'forum/', include(forum_patterns)),

    # Include planets urls
    path(r'planet/', include(planet_patterns)),

    # Include the accounts urls
    path(r'accounts/', include(accounts_urls)),

]

if settings.PAGEDOWN_IMAGE_UPLOAD_ENABLED:

    urlpatterns += [
        # Pagedown image upload url.
        path('pagedown/image-upload/', image_upload_view, name="pagedown-image-upload")
    ]


if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT, show_indexes=True)
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT, show_indexes=True)

biostar/urls.py
# Default url patters for the engine.
urlpatterns = []



biostar/transfer/models.py
from django.db import models


class Manager(models.Manager):

    def get_queryset(self):
        """
        Route all queries to biostar2 database
        """
        return super().get_queryset().using("biostar2")


class UsersProfile(models.Model):
    website = models.CharField(max_length=255)
    info = models.TextField(blank=True, null=True)
    user_id = models.IntegerField(unique=True)
    uuid = models.CharField(unique=True, max_length=255)
    digest_prefs = models.IntegerField()
    opt_in = models.BooleanField()
    twitter_id = models.CharField(max_length=255)
    my_tags = models.TextField()
    flag = models.IntegerField()
    last_login = models.DateTimeField()
    location = models.CharField(max_length=255)
    watched_tags = models.CharField(max_length=100)
    message_prefs = models.IntegerField()
    scholar = models.CharField(max_length=255)
    id = models.IntegerField(primary_key=True)  # AutoField?
    date_joined = models.DateTimeField()

    objects = Manager()

    class Meta:
        managed = False
        db_table = 'users_profile'


class UsersUser(models.Model):
    NEW_USER, TRUSTED, SUSPENDED, BANNED = range(4)
    STATUS_CHOICES = ((NEW_USER, 'New User'), (TRUSTED, 'Trusted'), (SUSPENDED, 'Suspended'), (BANNED, 'Banned'))

    status = models.IntegerField()
    is_staff = models.BooleanField()
    name = models.CharField(max_length=255)
    site_id = models.IntegerField(blank=True, null=True)
    is_active = models.BooleanField()
    id = models.IntegerField(primary_key=True)  # AutoField?
    score = models.IntegerField()
    last_login = models.DateTimeField()
    new_messages = models.IntegerField()
    activity = models.IntegerField()
    is_admin = models.BooleanField()
    password = models.CharField(max_length=128)
    type = models.IntegerField()
    email = models.CharField(unique=True, max_length=255)
    badges = models.IntegerField()
    flair = models.CharField(max_length=15)

    objects = Manager()

    class Meta:
        managed = False
        db_table = 'users_user'

    @property
    def profile(self):
        return UsersProfile.objects.filter(user_id=self.id).first()


class PostsPost(models.Model):
    site_id = models.IntegerField(blank=True, null=True)
    rank = models.FloatField()
    creation_date = models.DateTimeField()
    reply_count = models.IntegerField()
    tag_val = models.CharField(max_length=100)
    id = models.IntegerField(primary_key=True)
    view_count = models.IntegerField()
    thread_score = models.IntegerField()
    title = models.CharField(max_length=200)
    has_accepted = models.BooleanField()
    vote_count = models.IntegerField()
    content = models.TextField()
    parent_id = models.IntegerField(blank=True, null=True)
    comment_count = models.IntegerField()
    html = models.TextField()
    type = models.IntegerField()
    status = models.IntegerField()
    book_count = models.IntegerField()
    root_id = models.IntegerField(blank=True, null=True)
    lastedit_user_id = models.IntegerField()
    sticky = models.BooleanField()
    lastedit_date = models.DateTimeField()
    changed = models.BooleanField()
    subs_count = models.IntegerField()
    author_id = models.IntegerField()

    objects = Manager()

    class Meta:
        managed = False
        db_table = 'posts_post'

    @property
    def parent(self):
        return self.objects.filter(id=self.parent_id).first()

    @property
    def root(self):
        return self.objects.filter(id=self.root_id).first()

    @property
    def author(self):
        return UsersUser.objects.filter(id=self.author_id).first()

    @property
    def lastedit_user(self):
        return UsersUser.objects.filter(id=self.lastedit_user_id).first()


class PostsSubscription(models.Model):
    id = models.IntegerField(primary_key=True)
    user_id = models.IntegerField()
    post_id = models.IntegerField()
    type = models.IntegerField()
    date = models.DateTimeField()

    objects = Manager()

    class Meta:
        managed = False
        db_table = 'posts_subscription'
        unique_together = (('user_id', 'post_id'),)

    @property
    def user(self):
        return UsersUser.objects.filter(id=self.user_id).first()

    @property
    def post(self):
        return PostsPost.objects.filter(id=self.post_id).first()


class PostsVote(models.Model):
    id = models.IntegerField(primary_key=True)
    author_id = models.IntegerField()
    post_id = models.IntegerField()
    type = models.IntegerField()
    date = models.DateTimeField()

    objects = Manager()

    class Meta:
        managed = False
        db_table = 'posts_vote'

    @property
    def author(self):
        return UsersUser.objects.filter(id=self.author_id).first()

    @property
    def post(self):
        return PostsPost.objects.filter(id=self.post_id).first()


class BadgesBadge(models.Model):
    id = models.IntegerField(primary_key=True)
    name = models.CharField(max_length=50)
    type = models.IntegerField()
    unique = models.BooleanField()
    count = models.IntegerField()
    desc = models.CharField(max_length=200)
    icon = models.CharField(max_length=250)

    objects = Manager()

    class Meta:
        managed = False
        db_table = 'badges_badge'


class BadgesAward(models.Model):
    badge_id = models.IntegerField()
    user_id = models.IntegerField()
    date = models.DateTimeField()
    context = models.CharField(max_length=1000)

    objects = Manager()

    class Meta:
        managed = False
        db_table = 'badges_award'

    @property
    def badge(self):
        return BadgesBadge.objects.filter(id=self.badge_id).first()

biostar/forum/templates/herald/herald_base.html
{% extends "forum_list.html" %}
{% load forum_tags %}
{% load static %}
{% load humanize %}
{% load cache %}

{% block title %}
    Biostar Herald
{% endblock %}

{% block headtitle %}
    Biostar Herald
{% endblock %}

{% block css %}
    <style>
        .item.herald {
            padding: 1em;
        }

        .item.herald .description {
            padding-top: 1em;
        }

        .herald.Declined {
            background-color: #fedce0;
        }

        .herald.Accepted {
            background-color: #e8ffe1;
        }

        .herald.Submitted {
            background-color: #ffefd9;
        }

        .herald.Published {
            background-color: #ececec;
        }


    </style>
{% endblock %}

{% block body %}

    <div class="ui vertical segment">

        <h2 class="ui header">
            <img src="{% static 'images/news-herald.png' %}">
            <div class="content">
                Biostar Herald
                <div class="sub header">Share bioinformatics links from across the web.</div>
            </div>

        </h2>

        <p>
            Moderators will review each submission and may accept or reject them.
            Accepted submissions will be published in the next edition of the Biostar Herald.
        </p>
    </div>

    <div class="ui segment form-wrap" style="width: 61%;margin:auto;margin-top:30px;">

        <form method="post" class="ui form" action="{% url 'herald_list' %}">
            {% form_errors form %}

            {% csrf_token %}

            <div class="required field">
                <label>Link</label>
                {{ form.url }}
                <p class="muted">The URL to the content: tweet, repository, paper etc. Must be bioinformatics
                    related!</p>
            </div>

            <div class="field">
                <label>Why is the link interesting? (optional description)</label>
                {{ form.text }}
                <p class="muted">Provide more context of why the link is interesting. Give
                    readers a reason to visit the site. Help curate the information on the web. (Markdown OK) </p>
            </div>
            {% if allow_submit %}
            <button type="submit" class="ui submit green button">
                <i class="check icon"></i>Submit
            </button>
            {% else %}
            <div class="ui disabled green button">
                <i class="check icon"></i>Submit
            </div>

            <div class="ui compact message">
                <i class="exclamation circle icon"></i>You have submitted the maximum number of pending links.
                Please wait until your current submissions are accepted.
            </div>
            {% endif %}

        </form>

    </div>


    {% if request.user.is_staff or  request.user.is_superuser %}
        <div class="ui divider"></div>
        <p><a class="ui blue button" href="{% url 'herald_publish' %}"><i class="book icon"></i>Publish new Issue</a>
        <a class="herald-sub ui button"><i class="mail icon"></i>Toggle Email Subscription</a>
        </p>

        <p>Publishing will collate the accepted items and generates a post out of them</p>

        <p>Publishing will happen automatically in the future, this button here is available during testing</p>
        <div class="ui divider"></div>
    {% endif %}

    {% include 'herald/herald_list.html' %}


{% endblock %}

{% block sidebar %}

    <h3 class="ui header muted">
        Community Guidelines
    </h3>
    <ol style="list-style-type: upper-roman;">
        <li>Share code, videos, tweets, papers relating to bioinformatics.</li>
        <li>Moderators can accept submitted topics.</li>
        <li>Accepted submissions are auto-published on a regular basis
            .
        </li>
    </ol>


{% endblock %}

biostar/forum/templates/herald/herald_email.html
{% load accounts_tags %}
{%  block subject %}

    {{ post.title }}

{% endblock %}

{% block html %}

    A new issue of the <a href="{{ protocol }}://{{ domain }}{{ port }}">Biostar Herald</a> was published.

    <p>
     <a href="{{ protocol }}://{{ domain }}{{ post.get_absolute_url }}">{{ post.title }}</a>
        {{ post.html|safe }}
    </p>

    <hr>
    <p class="muted" >
        You may visit {{ protocol }}://{{ domain }}{{ post.get_absolute_url }}
    </p>

    <p>The Biostar Team</p>

{% endblock %}

{% block text %}

    A new issue of the Biostar Herald was published.

    {{ post.title }}:

    {{ post.content }}

    You may visit {{ protocol }}://{{ domain }}{{ post.get_absolute_url }}

    The Biostar Team


{% endblock %}

biostar/forum/templates/herald/herald_item.html
{% load humanize %}
{% load forum_tags %}

<div class="content">

    <em>{{ story.creation_date|naturaltime }}</em>

    <a href="{{ story.author.profile.get_absolute_url }}">{{ story.author.profile.name }}</a> submitted


    {#  Story text #}
    {% if story.title %}
        <a href="{{ story.url }}">{{ story.title }}</a> ({{ story.domain }})
    {% else %}
        <a href="{{ story.url }}">{{ story.url }}</a>
    {% endif %}


    {#  Story text #}
    {% if story.text %}
        <div class="description">
            {{ story.text }}
        </div>
    {% endif %}

    {#  Story status #}
    <div class="description">
        State:
        {% if story.post %}
            <a href="{{ story.post.get_absolute_url }}">{{ story.get_status_display }}</a>
            <em>{{ story.lastedit_date|naturaltime }} </em> &bull;
            reviewed
        {% else %}
            <b>{{ story.get_status_display }}</b>&bull; <em>{{ story.lastedit_date|naturaltime }} </em>
        {% endif %}

        {% if story.editor %}
            by <a href="{{ story.editor.profile.get_absolute_url }}">{{ story.editor.profile.name }}</a>
        {% endif %}

    </div>

    {# Action buttons #}
    {% if user.profile.is_moderator and not story.published %}
        <div class="description">
            <a class="ui basic label" data-value="accept"><i class="green check icon"></i>
                Accept
            </a>
            &bull;
            <a class="ui basic label" data-value="decline"><i class="orange times icon"></i>
                Decline
            </a>
        </div>
    {% endif %}
</div>

biostar/forum/templates/herald/herald_list.html
{% load forum_tags %}
{% load humanize %}

<div class="ui vertical segment">

    <div class="ui dropdown">

        <div class="text"> {{ show|capfirst }} Issues</div>
        <i class="dropdown icon"></i>
        <div class="menu">
            <a class="item" href="{% url 'herald_list' %}#list">Upcoming Issues</a>
            <a class="item" href="{% url 'herald_list' %}?show=published#list">Published Issues</a>
        </div>
    </div>

    <div class="ui header">Latest Submissions</div>

    <div class="ui relaxed divided list" id="list">

        {% for story in stories %}

            <div class="item herald {{ story.get_status_display }}" data-value="{{ story.pk }}">
                {% herald_item item=story %}
            </div>
        {% empty %}
            <div class="ui blue message">No results found.</div>

        {% endfor %}

    </div>

</div>